/*1:*/
#line 9 "aweb.w"

#include <stdio.h> 
#include <string.h> 
#include <stdlib.h> 
#define FEHLER(n, m) fflush(NULL); fprintf(stderr,n, m); fflush(NULL);

#define MOD_ANFANG 1
#define MOD_AUFRUF 2
#define MOD_SOURCE 3
#define MOD_NULL 0

#define ZLEN  1024
#define ZLENREAD 512
#define CYCLE  10
#define LISTLEN  9

#define SHOWDOT  10
#define SHOWNUM  50

#define TRUE  -1
#define FALSE  0

typedef unsigned char bool;

struct zeile{
struct zeile*next;
char*text;};

struct modul{
char*name;
int used;
struct modul*next;
struct zeile*kopf,*source;};

int i,lines;
struct zeile*zptr1,*zptr2,*zptr3;
struct modul erstesmodul;
char zeile1[ZLEN],zeile2[ZLEN];
char lab[ZLEN],bef[ZLEN],ope[ZLEN],kom[ZLEN];
char llab[ZLEN],lbef[ZLEN],lope[ZLEN],lkom[ZLEN];
char liste[LISTLEN][2][ZLEN];

/*2:*/
#line 57 "aweb.w"

/*3:*/
#line 72 "aweb.w"

int charakter(char*text){
int ergebnis;
char*zptr;

ergebnis= MOD_NULL;
zptr= text;
while((*zptr==' ')||(*zptr=='\t'))zptr++;
if(*zptr=='@'){
zptr++;
if(((*zptr<='9')&&(*zptr>='0'))||(*zptr=='+')){
if(*zptr=='+')ergebnis= MOD_SOURCE;
else ergebnis= MOD_ANFANG;
}
else ergebnis= MOD_AUFRUF;
}
return(ergebnis);
}

/*:3*/
#line 58 "aweb.w"

/*4:*/
#line 95 "aweb.w"

int semic(char*text){
int ergebnis,i;
bool inkom;

ergebnis= -1;
inkom= FALSE;
for(i= 0;i<strlen(text);i++){
if((text[i]==39)||(text[i]==34)){
if(inkom)inkom= FALSE;else inkom= TRUE;}
if((text[i]==';')&&(!inkom)&&(ergebnis==-1))ergebnis= i;}
return(ergebnis);}

/*:4*/
#line 59 "aweb.w"

/*5:*/
#line 113 "aweb.w"

void parse(char*text){
int i;
char puffer[ZLEN],*zptr,merker;

for(i= 0;i<ZLEN;i++){
lab[i]= '\0';
bef[i]= '\0';
ope[i]= '\0';
kom[i]= '\0';
}

strcpy(puffer,text);
if(!((puffer[0]=='@')&&(puffer[1]=='+'))){
/*6:*/
#line 141 "aweb.w"

i= semic(puffer);
if(i!=-1){
zptr= &puffer[i];
strcpy(kom,zptr);
if(zptr==puffer)puffer[0]= '\0';
else{
zptr--;
while((*zptr==' ')||(*zptr=='\t'))zptr--;
zptr++;
*zptr= '\0';
}
}

/*:6*/
#line 127 "aweb.w"

if(puffer[0]){/*7:*/
#line 161 "aweb.w"

if((puffer[0]!=' ')&&(puffer[0]!='\t')){
zptr= puffer;
while((*zptr!=' ')&&(*zptr!='\t')&&(*zptr))zptr++;
merker= *zptr;
*zptr= '\0';
strcpy(lab,puffer);
*zptr= merker;
if(merker){
strcpy(puffer,zptr);
zptr= puffer;
while((*zptr==' ')||(*zptr=='\t'))zptr++;
strcpy(puffer,zptr);
}
else puffer[0]= '\0';
}
else{
zptr= puffer;
while((*zptr==' ')||(*zptr=='\t'))zptr++;
if(*zptr)strcpy(puffer,zptr);
else puffer[0]= '\0';
}

/*:7*/
#line 128 "aweb.w"
}
if(puffer[0]){/*8:*/
#line 188 "aweb.w"

zptr= puffer;
while((*zptr!=' ')&&(*zptr!='\t')&&(*zptr))zptr++;
merker= *zptr;
*zptr= '\0';
strcpy(bef,puffer);
*zptr= merker;
if(merker){
strcpy(puffer,zptr);
zptr= puffer;
while((*zptr==' ')||(*zptr=='\t'))zptr++;
strcpy(puffer,zptr);
}
else puffer[0]= '\0';

/*:8*/
#line 129 "aweb.w"
}
if(puffer[0])strcpy(ope,puffer);
}
if(strlen(lab)> strlen(llab))strcpy(llab,lab);
if(strlen(bef)> strlen(lbef))strcpy(lbef,bef);
if(strlen(ope)> strlen(lope))strcpy(lope,ope);
if(strlen(kom)> strlen(lkom))strcpy(lkom,kom);
}

/*:5*/
#line 60 "aweb.w"

/*9:*/
#line 205 "aweb.w"

void nokom(char*text){
char*zptr;
int i;

i= semic(text);
if(i!=-1){
zptr= &text[i];
if(zptr==text)text[0]= '\0';
else{
zptr--;
while((*zptr==' ')||(*zptr=='\t'))zptr--;
zptr++;
*zptr= '\0';
}
}
}

/*:9*/
#line 61 "aweb.w"

/*10:*/
#line 225 "aweb.w"

void modname(char*text){
char*zptr;

strcpy(zeile2,text);
nokom(zeile2);
zptr= zeile2;
while((*zptr==' ')||(*zptr=='\t'))zptr++;
zptr++;
strcpy(zeile2,zptr);
}

/*:10*/
#line 62 "aweb.w"

/*11:*/
#line 240 "aweb.w"

void kopiere(struct zeile*z,char*name){
struct zeile*von= NULL,*nach,*sicher;
struct modul*mptr;

mptr= &erstesmodul;
while(mptr->next){
mptr= mptr->next;
if(strcmp(mptr->name,name)==0)von= mptr->source;
}
nach= z;
while((von)&&(charakter(von->text)!=MOD_ANFANG)){
sicher= nach->next;
nach->next= (struct zeile*)malloc(sizeof(struct zeile));
nach= nach->next;
nach->next= sicher;
nach->text= (char*)malloc(strlen(von->text)+1);
strcpy(nach->text,von->text);
von= von->next;
}
}

/*:11*/
#line 63 "aweb.w"

/*12:*/
#line 268 "aweb.w"

void ersetze(char*text){
char von[ZLEN],nach[ZLEN],*c1,*c2;
int i,j;
bool gefunden;

for(i= 0;i<ZLEN;i++){
von[i]= '\0';
nach[i]= '\0';
}
strcpy(von,text);
c1= von;c2= nach;
while(*c1){
gefunden= FALSE;
for(i= 0;i<LISTLEN;i++){
if(strncmp(liste[i][0],c1,strlen(liste[i][0]))==0){
gefunden= TRUE;
strcat(nach,liste[i][1]);
while(*c2)c2++;
for(j= 0;j<strlen(liste[i][0]);j++)c1++;
}
}
if(!gefunden){
*c2= *c1;
c1++;
c2++;
*c2= '\0';
}
}
strcpy(text,nach);
}

/*:12*/
#line 64 "aweb.w"

/*13:*/
#line 303 "aweb.w"

void addiere(struct zeile*z,char*text){
z->next= (struct zeile*)malloc(sizeof(struct zeile));
z= z->next;
z->next= NULL;
z->text= (char*)malloc(strlen(text)+1);
strcpy(z->text,text);
}

/*:13*/
#line 65 "aweb.w"

/*14:*/
#line 315 "aweb.w"

void writef(struct zeile*z,char*name){
int lines;
FILE*fp;

lines= 0;
fp= fopen(name,"w");
if(fp){
printf(".");
while(z->next){
z= z->next;
fprintf(fp,"%s\n",z->text);
lines++;
if((lines%SHOWDOT)==0)printf(".");
if((lines%SHOWNUM)==0)printf("%i",lines);
}
printf("\n");
}
else printf("File >%s< kann nicht geschrieben werden!\n",name);
}

/*:14*/
#line 66 "aweb.w"

/*15:*/
#line 338 "aweb.w"

void freelines(struct zeile*z){
struct zeile*z1,*z2;

do{
z1= z;z2= z;
while(z1->next){
z2= z1;
z1= z1->next;
}
if(z1!=z){
if(z1->text)free(z1->text);
free(z1);
}
z2->next= NULL;
}while(z->next);
}

/*:15*/
#line 67 "aweb.w"


/*:2*/
#line 51 "aweb.w"

/*16:*/
#line 361 "aweb.w"

int main(int argc,char*argv[]){
int ergebnis;
bool argok,modulok,mda,intex,insource;
bool weave,tangle,verbatim;
char*zptr;
FILE*infile= NULL;
char infname[ZLEN],asmfname[ZLEN],texfname[ZLEN];
struct zeile inroot,asmroot,texroot;
struct modul*mptr1,*mptr2;

printf("\nA-Web 1.0\n=========\n");
/*17:*/
#line 397 "aweb.w"

ergebnis= 0;
argok= FALSE;
weave= FALSE;
tangle= FALSE;
verbatim= FALSE;

inroot.next= NULL;inroot.text= NULL;
asmroot.next= NULL;asmroot.text= NULL;

erstesmodul.name= NULL;erstesmodul.used= 0;
erstesmodul.next= NULL;erstesmodul.kopf= NULL;erstesmodul.source= NULL;

for(i= 0;i<ZLEN;i++){
llab[i]= '\0';
lbef[i]= '\0';
lope[i]= '\0';
lkom[i]= '\0';
}

strcpy(liste[0][0],"$");strcpy(liste[0][1],"\\$");
strcpy(liste[1][0],"&");strcpy(liste[1][1],"\\&");
strcpy(liste[2][0],"%");strcpy(liste[2][1],"\\%");
strcpy(liste[3][0],"#");strcpy(liste[3][1],"\\#");
strcpy(liste[4][0],"_");strcpy(liste[4][1],"\\_");
strcpy(liste[5][0],"<");strcpy(liste[5][1],"$<$");
strcpy(liste[6][0],">");strcpy(liste[6][1],"$>$");
strcpy(liste[7][0],"\t");strcpy(liste[7][1]," ");
strcpy(liste[8][0]," ");strcpy(liste[8][1]," ");

/*:17*/
#line 373 "aweb.w"

/*18:*/
#line 430 "aweb.w"

if(argc==3){
zptr= argv[1];
if(*zptr=='-'){
zptr++;
while(*zptr){
switch(*zptr){
case'v':{verbatim= TRUE;break;}
case't':{tangle= TRUE;break;}
case'w':{weave= TRUE;break;}
}
zptr++;
}
}
strcpy(infname,argv[2]);
infile= fopen(infname,"r");
if((infile)&&((tangle)||(weave)))argok= TRUE;
}

/*:18*/
#line 374 "aweb.w"

if(argok){
/*19:*/
#line 452 "aweb.w"

if(verbatim){
printf("Vorbereitungen\n");
printf("--------------\n");
if(tangle)printf("Erzeuge Source\n");
if(weave)printf("Erzeuge Dokumentation\n");
printf("Einlesen des Eingabefiles\n");
}
lines= 0;
printf(".");
do{
for(i= 0;i<ZLEN;i++)zeile1[i]= '\0';
fgets(zeile1,ZLENREAD,infile);
if(zeile1[0]){
zeile1[strlen(zeile1)-1]= '\0';
if(zeile1[0]){
lines++;
if(verbatim){
if((lines%SHOWDOT)==0)printf(".");
if((lines%SHOWNUM)==0)printf("%i",lines);
}
zptr1= &inroot;
while(zptr1->next)zptr1= zptr1->next;
addiere(zptr1,zeile1);
zptr1= zptr1->next;
}
else zeile1[0]= 'x';
}
}while(zeile1[0]);
printf("\n");

/*:19*/
#line 376 "aweb.w"

/*20:*/
#line 489 "aweb.w"

if(verbatim)printf("Modulcheck; erster Durchlauf\n");
modulok= TRUE;
intex= FALSE;
insource= FALSE;
zptr1= &inroot;
while(zptr1->next){
zptr1= zptr1->next;
switch(charakter(zptr1->text)){
case MOD_ANFANG:{/*21:*/
#line 549 "aweb.w"

mptr1= &erstesmodul;
while(mptr1->next)mptr1= mptr1->next;
mptr1->next= (struct modul*)malloc(sizeof(struct modul));
mptr1= mptr1->next;
mptr1->name= (char*)malloc(strlen(zptr1->text)-1);
strcpy(mptr1->name,&(zptr1->text[2]));
mptr1->used= 0;
mptr1->next= NULL;
mptr1->kopf= zptr1->next;
mptr1->source= NULL;
if(verbatim)printf("Moduldefinition >%s< gefunden\n",mptr1->name);
if(intex){
modulok= FALSE;
mptr1= &erstesmodul;mptr2= &erstesmodul;
while(mptr1->next){
mptr2= mptr1;
mptr1= mptr1->next;
}
printf("Moduldefinition von >%s< nicht vollstaendig\n",mptr2->name);
}

/*:21*/
#line 498 "aweb.w"
intex= TRUE;insource= FALSE;break;}
case MOD_SOURCE:{/*22:*/
#line 573 "aweb.w"

mptr1= &erstesmodul;
while(mptr1->next)mptr1= mptr1->next;
mptr1->source= zptr1->next;
if(verbatim)printf("Source von >%s< gefunden\n",mptr1->name);

/*:22*/
#line 499 "aweb.w"
intex= FALSE;insource= TRUE;break;}
}
if(insource)parse(zptr1->text);
}
erstesmodul.next->used= 1;
if(verbatim){
printf("Laengstes Label     : %s\n",llab);
printf("Laengster Befehl    : %s\n",lbef);
printf("Laengster Operand   : %s\n",lope);
printf("Laengster Kommentar : %s\n",lkom);
printf("Modulcheck; zweiter Durchlauf\n");
}
zptr1= &inroot;
while(zptr1->next){
zptr1= zptr1->next;
if(charakter(zptr1->text)==MOD_AUFRUF){
modname(zptr1->text);
if(verbatim)printf("Bearbeite Aufruf von >%s<\n",zeile2);
mda= FALSE;
mptr1= &erstesmodul;
while(mptr1->next){
mptr1= mptr1->next;
if(strcmp(mptr1->name,zeile2)==0){
mptr1->used++;
mda= TRUE;
}
}
if(!mda){
modulok= FALSE;
printf("Modul >%s< nicht gefunden\n",zeile2);
}
}
}
mptr1= &erstesmodul;
if(mptr1->next==NULL){
printf("Kein erstes Modul definiert!\n");
modulok= FALSE;
}
else{
while(mptr1->next){
mptr1= mptr1->next;
if(mptr1->used==0)
printf("Warnung: Modul >%s< wird nicht genutzt\n",mptr1->name);
mptr1->used= 0;
}
erstesmodul.next->used= 1;
}

/*:20*/
#line 377 "aweb.w"

if(modulok){
if(tangle){/*23:*/
#line 585 "aweb.w"

if(verbatim){
printf("\nAusgabe des Sourcefiles\n");
printf("-----------------------\n");
}
modulok= TRUE;
/*24:*/
#line 599 "aweb.w"

if(verbatim)printf("Kopiere erstes Modul\n");
zptr1= &asmroot;
zptr= erstesmodul.next->name;
kopiere(zptr1,zptr);

/*:24*/
#line 591 "aweb.w"

/*25:*/
#line 609 "aweb.w"

do{
mda= FALSE;
zptr1= &asmroot;
while(zptr1->next){
zptr1= zptr1->next;
if(charakter(zptr1->text)==MOD_AUFRUF){/*26:*/
#line 622 "aweb.w"

mda= TRUE;
modname(zptr1->text);
mptr1= &erstesmodul;
while(mptr1->next){
mptr1= mptr1->next;
if(strcmp(zeile2,mptr1->name)==0)mptr1->used++;
if(mptr1->used> CYCLE){
modulok= FALSE;
printf("Modul >%s< wurde zu oft aufgerufen!\n",zeile2);
}
}
if(verbatim)printf("Ersetze >%s<\n",zeile2);
if(modulok){
kopiere(zptr1,zeile2);
zptr2= &asmroot;
while(zptr2->next!=zptr1)zptr2= zptr2->next;
zptr2->next= zptr1->next;
free(zptr1->text);
free(zptr1);
zptr1= zptr2->next;
}

/*:26*/
#line 615 "aweb.w"
}
}
}while((mda)&&(modulok));

/*:25*/
#line 592 "aweb.w"

/*27:*/
#line 647 "aweb.w"

zptr1= &asmroot;
while(zptr1->next){
zptr1= zptr1->next;
nokom(zptr1->text);
}

/*:27*/
#line 593 "aweb.w"

if(modulok){/*28:*/
#line 656 "aweb.w"

strcpy(asmfname,infname);
asmfname[strlen(asmfname)-1]= '\0';
strcat(asmfname,"asm");
zptr1= &asmroot;
writef(zptr1,asmfname);

/*:28*/
#line 594 "aweb.w"
}

/*:23*/
#line 379 "aweb.w"
}
if(weave){/*29:*/
#line 675 "aweb.w"

/*30:*/
#line 739 "aweb.w"

strcpy(zeile1,"\\input awebmac");
zptr1= &texroot;
addiere(zptr1,zeile1);
zptr1= zptr1->next;
ersetze(llab);
ersetze(lbef);
ersetze(lope);
ersetze(lkom);
strcpy(zeile1,"\\settabs\\+ ");
strcat(zeile1,llab);
strcat(zeile1,"\\quad\\quad & ");
strcat(zeile1,lbef);
strcat(zeile1,"\\quad\\quad & ");
strcat(zeile1,lope);
strcat(zeile1,"\\quad\\quad & ");
strcat(zeile1,lkom);
strcat(zeile1," \\cr");
addiere(zptr1,zeile1);
zptr1= zptr1->next;

/*:30*/
#line 676 "aweb.w"

intex= FALSE;insource= FALSE;
zptr1= &inroot;
zptr2= &texroot;
while(zptr2->next)zptr2= zptr2->next;
while(zptr1->next){
zptr1= zptr1->next;
for(i= 0;i<ZLEN;i++)zeile1[i]= '\0';
if((charakter(zptr1->text)==MOD_ANFANG)||
(charakter(zptr1->text)==MOD_SOURCE)){
if(charakter(zptr1->text)==MOD_ANFANG){
/*31:*/
#line 763 "aweb.w"

switch(zptr1->text[1]){
case'1':{strcpy(zeile1,"\\EINS{");break;}
case'2':{strcpy(zeile1,"\\ZWEI{");break;}
case'3':{strcpy(zeile1,"\\DREI{");break;}
case'4':{strcpy(zeile1,"\\VIER{");break;}
case'5':{strcpy(zeile1,"\\FUEN{");break;}
case'6':{strcpy(zeile1,"\\SECH{");break;}
default:{strcpy(zeile1,"\\SECH{");break;}
}
strcat(zeile1,&zptr1->text[2]);
strcat(zeile1,"}");
addiere(zptr2,zeile1);
zptr2= zptr2->next;

/*:31*/
#line 687 "aweb.w"

intex= TRUE;
insource= FALSE;
}
else{
intex= FALSE;
insource= TRUE;
strcpy(zeile1,"\\medskip");
addiere(zptr2,zeile1);
zptr2= zptr2->next;
}
}
else{
if(insource){
parse(zptr1->text);
ersetze(lab);
ersetze(bef);
ersetze(ope);
ersetze(kom);
strcpy(zeile1,"\\+ ");
strcat(zeile1,lab);
strcat(zeile1," & ");
if(bef[0]=='@'){
strcat(zeile1,bef);
strcat(zeile1," ");
strcat(zeile1,ope);
strcat(zeile1," & & ");
}
else{
strcat(zeile1,bef);
strcat(zeile1," & ");
strcat(zeile1,ope);
strcat(zeile1," & ");
}
strcat(zeile1,kom);
strcat(zeile1," \\cr");
}
else strcpy(zeile1,zptr1->text);
addiere(zptr2,zeile1);
zptr2= zptr2->next;
}
}
addiere(zptr2,"\\inhaltsverzeichnis");
zptr2= zptr2->next;
addiere(zptr2,"\\end");
strcpy(texfname,infname);
texfname[strlen(texfname)-1]= '\0';
strcat(texfname,"tex");
writef(&texroot,texfname);

/*:29*/
#line 380 "aweb.w"
}
}
/*32:*/
#line 782 "aweb.w"

if(verbatim){
printf("\nBeendigung des Programms\n");
printf("------------------------\n");
printf("Freigabe des Eingabefiles\n");
}
fclose(infile);

if(verbatim)printf("Freigabe der Originalzeilen\n");
freelines(&inroot);

if(verbatim)printf("Freigabe der Sourcezeilen\n");
freelines(&asmroot);

if(verbatim)printf("Freigabe der Modulliste\n");
do{
mptr1= &erstesmodul;mptr2= &erstesmodul;
while(mptr1->next){
mptr2= mptr1;
mptr1= mptr1->next;
}
if(mptr1->name)free(mptr1->name);
if(mptr1!=&erstesmodul)free(mptr1);
mptr2->next= NULL;
}while(erstesmodul.next);
/*:32*/
#line 382 "aweb.w"

}
else{
ergebnis= -1;
printf("Aufruf:\n\n");
printf("aweb -<tw>[v] filename\n");
printf("  t : Sourceerzeugung\n");
printf("  w : Dokumenterzeugung\n");
printf("  v : Informationen zum Programmlauf\n");
}
return(ergebnis);
}

/*:16*/
#line 52 "aweb.w"


/*:1*/
